/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package model2;

import generated.ObjectFactory;
import generated.Produkt;
import generated.Warenkorb;
import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Set;
import javax.swing.JOptionPane;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.Unmarshaller;
import javax.xml.bind.Marshaller;

/**
 *
 * @author micha
 */
public class XMLZugriff {

    private ObjectFactory objF;
    private model2.Produkt produkt;
    private String verzeichnis;
    private generated.Warenkorb warenkorb;
    private generated.Produkt katalog;

    public XMLZugriff(String verzeichnis) {
        this.verzeichnis = verzeichnis;
        objF = new generated.ObjectFactory();
        this.katalog = this.deSerializeKatalog();
    }

    private generated.Produkt deSerializeKatalog() {
        Produkt produkt = null;
        
        try {
            //unmarshaller erzeugen und xml nach objekt deserialisieren
            JAXBContext context = JAXBContext.newInstance(Produkt.class);
            Unmarshaller u = context.createUnmarshaller();

            
            produkt = (Produkt) u.unmarshal(new File(verzeichnis + "/katalog.xml"));

        
        } catch (Exception e) {
            e.printStackTrace();
        }

        return produkt;
    }
    
    public void serializeProdukt() {
        //marshaller erzeugen und serialisieren
        try {
            JOptionPane.showMessageDialog(null, "katalog wird gespeichert");
            // create JAXB context and instantiate marshaller

            JAXBContext context = JAXBContext.newInstance(Produkt.class);

            Marshaller m = context.createMarshaller();
            m.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);

            // Write to System.out
            System.out.println("so sieht die katalog xml-datei aus:");
            m.marshal(this.katalog, System.out);

            // Write to File
            m.marshal(this.katalog, new File(verzeichnis + "/katalog.xml"));

        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    

    public List<generated.Produkt.Row> getGesamterKatalog() {
        return katalog.getRow();
    }

    public void serializeWarenkorb(Warenkorb warenkorb) {
        //marshaller erzeugen und serialisieren
        try {
            JOptionPane.showMessageDialog(null, "warenkorb wird gespeichert");
            // create JAXB context and instantiate marshaller

            JAXBContext context = JAXBContext.newInstance(generated.Warenkorb.class);

            Marshaller m = context.createMarshaller();
            m.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);

            // Write to System.out
            System.out.println("so sieht die warenkorb xml-datei aus:");
            m.marshal(warenkorb, System.out);

            //JOptionPane.showMessageDialog(null, verzeichnis + "/warenkorb.xml");
            // Write to File
            m.marshal(warenkorb, new File(verzeichnis + "/warenkorb.xml"));

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    ArrayList<String> getHerstellerListe() {
        ArrayList<String> herstellerListe = new ArrayList();

        for (generated.Produkt.Row zeile : this.katalog.getRow()) {
            herstellerListe.add(zeile.getHersteller());
        }

        return herstellerListe;

    }

    ArrayList<model2.Produkt> getProduktListe(String hersteller) throws Exception {

        ArrayList<model2.Produkt> produktListe = new ArrayList();

        for (generated.Produkt.Row zeile : this.katalog.getRow()) {
            if (zeile.getHersteller().equals(hersteller) || hersteller.equals("%")) {
                this.produkt = new model2.Produkt();
                this.setAttrsProdukt(zeile);
                produktListe.add(produkt);
            }
        }

        return produktListe;
    }

    public void updateBestand(String artNr, int abgang) {
        for (generated.Produkt.Row zeile : this.katalog.getRow()) {
            if (zeile.getArtNr().equals(artNr)) {
                int bestand = zeile.getBestand();
                bestand = bestand - abgang;
                zeile.setBestand(bestand);
            }
        }
    }

    private void setAttrsProdukt(generated.Produkt.Row zeile) {
        this.produkt.setArt_nr(zeile.getArtNr());
        this.produkt.setProduktname(zeile.getProduktname());
        this.produkt.setBeschreibung(zeile.getBeschreibung());
        this.produkt.setHersteller(zeile.getHersteller());
        this.produkt.setPreis(zeile.getPreis());
        this.produkt.setImg_name(zeile.getImgName());
        this.produkt.setImg_pfad(zeile.getImgPfad());
        this.produkt.setBestand(zeile.getBestand());
    }

    model2.Produkt getProdukt(String artNr) throws Exception {

        for (generated.Produkt.Row zeile : this.katalog.getRow()) {
            if (zeile.getArtNr().equals(artNr)) {
                this.produkt = new model2.Produkt();
                this.setAttrsProdukt(zeile);
            }
        }

        return produkt;
    }

    public void erzeugeAuftrag(String nname, String vname, String adresse, HashMap<String, Position> warenkorb) {
        this.warenkorb = new Warenkorb();

        this.warenkorb.setName(nname);
        this.warenkorb.setVname(vname);
        this.warenkorb.setAdresse(adresse);

        List positionen = this.warenkorb.getPosition();

        //ueber die uebergebene HashMap mit den postitions-objekten iterieren
        Set<String> keys = warenkorb.keySet();

        for (String artNr : keys) {
            Warenkorb.Position position = new Warenkorb.Position();
            position.setArtNr(artNr);
            position.setProduktname(warenkorb.get(artNr).getProdukt().getProduktname());
            position.setStueckzahl(warenkorb.get(artNr).getAnzahl());
            positionen.add(position);
        }

        this.serializeWarenkorb(this.warenkorb);
    }

    public static void main(String[] args) {
        XMLZugriff xmlz = new XMLZugriff("/home/teachers/dt/nbProject/web/WEB-INF/xml");
        List<Produkt.Row> produkte = xmlz.getGesamterKatalog();

        ArrayList<String> herstList = xmlz.getHerstellerListe();

        for (String item : herstList) {
            System.out.printf("hersteller:  --> %s\n", item);
        }

        System.out.println("" + ""
                + "art_nr\t"
                + "produktname\t"
                + "beschreibung\t"
                + "hersteller\t"
                + "preis\t"
                + "img_name\t"
                + "img_pfad\t"
                + "bestand");

        for (Produkt.Row zeile : produkte) {

            System.out.printf("%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\n",
                    zeile.getArtNr(),
                    zeile.getProduktname(),
                    zeile.getBeschreibung(),
                    zeile.getHersteller(),
                    zeile.getPreis(),
                    zeile.getImgName(),
                    zeile.getImgPfad(),
                    zeile.getBestand()
            );

        }

        Warenkorb warenkorb = new Warenkorb();

        warenkorb.setName("neumann");
        warenkorb.setVname("alfred e.");
        warenkorb.setAdresse("madboulevard 1a, 79098 freiburg");
        List positionen = warenkorb.getPosition();

        Warenkorb.Position position = new Warenkorb.Position();
        position.setArtNr("art_1234");
        position.setProduktname("madheft20160923");
        position.setStueckzahl(99);
        positionen.add(position);

        xmlz.serializeWarenkorb(warenkorb);

        for (String item : xmlz.getHerstellerListe()) {
            System.out.println("herstelle: " + item);
        }

    }

}
